#include <linux/init.h>
#include <linux/module.h>
#include <mach/gpio.h>
#include <linux/delay.h>
#include <linux/interrupt.h>
#include <mach/austin_hwid.h>
#include <linux/reboot.h>
#include <linux/syscalls.h>

MODULE_LICENSE("Dual BSD/GPL");

#define COVER_DETECT_NAME  "battery cover detection"
#define DELAY_TIME_MSEC 500     

int cover_det_int_gpio;
static struct work_struct cover_irqwork;

static void cover_work_func(struct work_struct *work);
static irqreturn_t cover_irq_handler(int irq, void *dev_id);
int cover_irq_setup(int cover_int_pin);
static int times=0;

static void cover_work_func(struct work_struct *work)
{
	int cover_status;

    times++;
    if (times == 1)
        return;     


    
    
    
    msleep(DELAY_TIME_MSEC);        
    
	cover_status = gpio_get_value(cover_det_int_gpio);

	if(cover_status == 0)
	{
	    

	}
	else
	{
	    
	    
	    
	    
	    
	    
	    kernel_power_off("Cover Removed");
	}
}

static irqreturn_t cover_irq_handler(int irq, void *dev_id)
{
	schedule_work(&cover_irqwork);
	return IRQ_HANDLED;
}

int cover_irq_setup(int cover_int_pin)
{
    int rc;
    rc = request_irq(MSM_GPIO_TO_INT(cover_int_pin), cover_irq_handler, 
                  IRQF_TRIGGER_RISING, COVER_DETECT_NAME, NULL);
    if (rc < 0)
    {
        printk("failed to request_irq, rc=%d\n", rc);    
    }     
    else
    {
        set_irq_wake(MSM_GPIO_TO_INT(cover_int_pin), 1);    
    }             
    return rc;
}

static int cover_init(void)
{
    printk("BootLog, +%s\n", __func__);
    
    
	if (system_rev < EVT2P2_Band125) {
	    cover_det_int_gpio = 107;
    }
    else {
        cover_det_int_gpio = 38;
    }
    gpio_tlmm_config(GPIO_CFG(cover_det_int_gpio, 0, GPIO_INPUT, GPIO_NO_PULL, GPIO_2MA), GPIO_ENABLE);
	
    
	INIT_WORK(&cover_irqwork, cover_work_func);   

	cover_irq_setup(cover_det_int_gpio);     


    printk("BootLog, -%s\n", __func__);    
    return 0;
}

static void cover_exit(void)
{
    printk(KERN_INFO "Goodbye, Detect cover\n");
}

module_init(cover_init);
module_exit(cover_exit);
